package org.exam;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Properties;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

public class AppDBHandler extends SQLiteOpenHelper {
	private SQLiteDatabase db;
	private ContentValues cv;
	private ObjectOutputStream oos;
	private ObjectInputStream ois;
	private static final String TAG = "AppDBHandler";

	public AppDBHandler(Context context){
		super(context,"FreeDrawdb.db",null,1);
		//this.onCreate(db);
		Log.i(TAG,"DB OPEN METHOD");
	}
	/*
	public AppDBHandler open() throws Exception{
		db = this.getWritableDatabase();
		return this;
	}
	*/
	
	
	@Override
	public void onCreate(SQLiteDatabase db) {
		// TODO Auto-generated method stub
		Log.i(TAG,"create Table ");
		
		StringBuffer sql = new StringBuffer(new String("create table if not exists freedraw("));
		sql.append("_id integer primary key autoincrement,");		
		sql.append("name text,");
		sql.append("list text)");
		db.execSQL(sql.toString());
		
		//db.close();
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// TODO Auto-generated method stub
		Log.i(TAG,"onUpgrade");
		db = this.getWritableDatabase();
		db.execSQL("drop table if exists feedraw");		
		onCreate(db);
		//db.close();
	}
	public Cursor getDBList(){
		db = this.getWritableDatabase();
		Cursor c= db.rawQuery("select _id,name,list from freedraw", null);
		//db.close();
		
		return c;
				
	}
	public String getEncodedByBase64about(ArrayList<Vortex> list){
		String result = "";
		try {
			ByteArrayOutputStream input = new ByteArrayOutputStream();
    		db = this.getWritableDatabase();
    		
    		oos = new ObjectOutputStream(input);
    		oos.writeObject(list);
    		oos.close();
    		
    		byte[] byteArr = input.toByteArray();
    		//String str = encodeBase64();
    		result = Base64.encodeBytes(byteArr);
		} catch (Exception e) {
			// TODO: handle exception
		}
		//db.close();
		return result;
	}
	public void updateListTODB(ArrayList<Vortex> list,int id){
		db = this.getWritableDatabase();
		try {
			
			Log.i("update","id : "+id);
			
			String s = getEncodedByBase64about(list);
			
    		cv = new ContentValues();
    		//ߺǸ +1Ѽ ϴ ޼ҵ屸
    		
    		cv.put("list",s);
    		
    		db.update("freedraw", cv, "_id="+id, null);
    		
    		//this.close();
    		
    		db.close();
		} catch (Exception e) {
			// TODO: handle exception
			Log.e(TAG,e.toString());
		}
		//db.close();
	}
	// ޼ҵ
	public void deleteItemFromDB(int pos){
		db = this.getWritableDatabase();
		try {
			String sql = "delete from freedraw where _id="+pos;
			db.execSQL(sql);
			db.close();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
	}
	public void writeListToDB(ArrayList<Vortex> list,String title){
		//String noteName = "note_0";
		//db = this.getWritableDatabase();
    	try {
    		String s = getEncodedByBase64about(list);
    		
    		cv = new ContentValues();
    		//ߺǸ +1Ѽ ϴ ޼ҵ屸
    		//if(!isNew)
    		
    		Log.i("writeListToDB",title);
    		cv.put("name", 
    				makeUnDuplicatedFileName(getLastNoteName(db,title)));
    		cv.put("list", s);
    		
    		//String name = makeUnDuplicatedFileName("note_0");
    		
    		db.insert("freedraw", null, cv);
    		
    		db.close();

		} catch (Exception e) {
			Log.i(TAG,e.toString());
			// TODO: handle exception
		}
		//db.close();
    }
    public String makeUnDuplicatedFileName(Properties proper){
    	String title = (String)proper.get("title");
    	boolean isDup = (Boolean)proper.get("isDup");
    	
    	if(title == null || title.equals("") || !isDup)
    		return title;
    	
    	if(!title.contains("_"))
    		title += "_0";
    	
    	int idx = title.lastIndexOf("_");
    	
    	int mName = Integer.parseInt(title.substring(idx+1,title.length()));
    	String fName = title.substring(0,idx);
    	++mName;
    	String lastName = fName+"_"+(mName);
    	
    	//Toast.makeText(this, lastName, Toast.LENGTH_SHORT).show();
    	
    	return lastName.trim();
    }
    public Properties getLastNoteName(SQLiteDatabase db,String title){
    	Properties proper = new Properties();
    	Boolean isDup = false;
    	
    	
    	if(title == null || title.equals(""))
    		title = "note_1";
    	
    	
    	db = this.getWritableDatabase();
    	
    	Cursor countC = db.rawQuery("select count(*) from freedraw " +
    			"where name = '"+title+"'", null);
    	
    	//Log.i(TAG,"123123123123123123");
    	if(countC.moveToFirst()){
    		if(countC.getInt(0)<=0){
    			proper.put("title", title);
    			proper.put("isDup", isDup);
    			Log.i(TAG,title);
    			return proper;
    		}
    			
    	}
    	
    	//countC.close();
    	
    	String sql = "select name from freedraw where _id ="; 
    	sql +=	" (select max(_id) from freedraw ";
    	sql +=	"where name = '"+title+"')";
    	
    	countC = db.rawQuery(sql, null);
    	
    	if(countC.moveToFirst()){
    		title = countC.getString(0);
    		Log.i(TAG+"_DB",title);
    	}
    	
    	
    	proper.put("title", title);
		proper.put("isDup", !isDup);
		
		countC.close();		
		db.close();
		return proper;
    }
    public boolean isDuplicate(String title){
    	
    	db = this.getWritableDatabase();
    	Cursor countC = db.rawQuery("select count(*) from freedraw " +
    			"where name = '"+title+"'", null);
    	
    	
    	Log.i(TAG,"title : "+title);
    	int count = 0;
    	while(countC.moveToNext()){
    		count = countC.getInt(0);
    		Log.i(TAG,""+count);
    		
    	}
    	db.close();
    	//countC.close();
    	
    	return count>0;//true ߺ false 
    	
    }
    public ArrayList<Vortex> getVortexList(int pos){
    	
    	ArrayList<Vortex> aList = new ArrayList<Vortex>();
    	
    	db = this.getWritableDatabase();
    	
    	String sql = "select list from freedraw where _id="+pos;
    	
    	
    	Cursor listCursor = db.rawQuery(sql, null);
    	
    	while(listCursor.moveToNext()){
    	
    		try {
    			ByteArrayInputStream input = new ByteArrayInputStream(
        				Base64.decode(listCursor.getString(0)));
    	
        		ois = new ObjectInputStream(input);
        
        		aList = (ArrayList)ois.readObject();
        
        		//Log.i(TAG,"list'size is "+aList.size());
			} catch (Exception e) {
				// TODO: handle exception
				Log.e(TAG,e.toString());
			}finally{
				try {
					ois.close();
					//listCursor.close();
					db.close();
				} catch (Exception e2) {
					// TODO: handle exception
				}
			}
			
    		
    	}
    	
    	
    	return aList;
    	
    }
}
