package org.exam;

import java.io.File;
import java.io.FileOutputStream;
import java.util.ArrayList;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Toast;


public class MainListActivity extends Activity {
    /** Called when the activity is first created. */
	private static final String TAG = "HelloAndroid";
	private ArrayList<Vortex> list;
	private AppDBHandler dbHandler;
	private boolean isNew = true;
	private static int _id;
	private String title;
	private MyView view;
	private Intent intent;
    
	@Override
    public void onCreate(Bundle savedInstanceState) {		
        super.onCreate(savedInstanceState);
        try {
        	dbHandler = new AppDBHandler(this);
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}

        intent = this.getIntent();
        
        _id = intent.getIntExtra("id", -1);
                        
        list = new ArrayList<Vortex>();
        
        title = intent.getStringExtra("title");
        
        if(_id<0){
        	
        	
        	if(dbHandler.isDuplicate(title)){
        		//Toast.makeText(this, "ߺ", Toast.LENGTH_SHORT).show();
        		new AlertDialog.Builder(this)
        									.setTitle("â")
        									.setMessage("ߺ ϸԴϴ")
        									.setIcon(R.drawable.icon)
        									.setPositiveButton("Ȯ", new DialogInterface.OnClickListener() {												
												@Override
												public void onClick(DialogInterface dialog, int which) {
													// TODO Auto-generated method stub	
													Intent intent = new Intent(MainListActivity.this,FreeDrawActivity.class);        		
									        		MainListActivity.this.startActivity(intent);
												}
											})
											.show();
        		
        	}
        		
        }
        else{        
        	list = dbHandler.getVortexList(_id);
        	isNew = false;// ƴҰ false;
        }
        
        view = new MyView(this);
        
        setContentView(view);

    }
	
    @Override
	public boolean onCreateOptionsMenu(Menu menu){
    	super.onCreateOptionsMenu(menu);
    	MenuItem item = menu.add(0,1,0,"");
    	item.setIcon(R.drawable.openfolder);
    	
    	MenuItem item2 = menu.add(0,2,0,"");
    	item2.setIcon(R.drawable.icon);
    	
    	MenuItem item3 = menu.add(0,3,0,"");
    	item3.setIcon(R.drawable.icon);
    	return true;
    }
    
    @Override
    public void onStop(){
    	super.onStop();
    	//writeListToDB;
    	//Toast.makeText(this, "STOP", Toast.LENGTH_SHORT).show();
    	
    	//writeListDB(list,isNew,title);
    	
    	
    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item){
    	switch(item.getItemId()){
    	case 1:
    		writeListDB(list,isNew,title);
    		break;
    	case 2:
    		if(_id<=0)
    			Toast.makeText(this, " ", Toast.LENGTH_LONG).show();
    		else
    			dbHandler.deleteItemFromDB(_id);
    			this.startActivity(new Intent(this,FreeDrawActivity.class));
    		break;
    	case 3:    		
    		this.startActivity(new Intent(this,FreeDrawActivity.class));
    		break;
    	}
    	
    	return true;
    }
    
    public Context setList(ArrayList<Vortex> list){
    	this.list = list;
    	
    	return this;
    }
    
    class MyView extends View{
    	Context context;    	
    	
    	private static final String TAG = "MyView";
    	public MyView(Context context) {
    		super(context);
    		this.context = context;
    		// TODO Auto-generated constructor stub
    		//Drawable drawable = this.getDr
    		
    		
    	}

    	public void onDraw(Canvas canvas){
		
    		Log.i(TAG,"onDraw");
    		
    		//canvas.setBitmap(mBack);
    		
    		Paint pnt = new Paint();		
    		pnt.setAntiAlias(true);
    		pnt.setStrokeWidth(5);
    		canvas.drawColor(Color.WHITE);
    		
    		
    		
    		//canvas.
    		for(int i=0;i<list.size();i++){
    			if(list.get(i).isDraw)
    			{
    				canvas.drawLine(list.get(i-1).x,list.get(i-1).y,list.get(i).x,list.get(i).y, pnt);
    				//bitmapCanvas.drawLine(list.get(i-1).x,list.get(i-1).y,list.get(i).x,list.get(i).y, pnt);
    			}
    		}

    	}
    	
    	public boolean onTouchEvent(MotionEvent me) {
    		// TODO Auto-generated method stub
    		
    		Log.i(TAG,"event");
    		int actionId = me.getAction();
    		switch(actionId){
    		case MotionEvent.ACTION_DOWN :
    			list.add(new Vortex(me.getX(),me.getY(),false));
    			return true;
    			
    		case MotionEvent.ACTION_MOVE :
    			list.add(new Vortex(me.getX(),me.getY(),true));
    			this.invalidate();
    			return true;
    			
    		}
    		//Log.i(TAG,me.getAction()+","+MotionEvent.ACTION_DOWN+","+MotionEvent.ACTION_MOVE);
    		//Log.i(TAG,me.getX()+","+me.getY());
    		
    		return false;
    	}
    }
    
    
    public void writeListDB(ArrayList<Vortex> list,boolean isNew,String mTitle){
    	try {
    		saveView(view);
    		Log.i(TAG,String.valueOf(isNew));
    		
	    	if(isNew)
				dbHandler.writeListToDB(list,title);//db list
			else
				dbHandler.updateListTODB(list,_id);
	    	
	    	Toast.makeText(this, "Ϸ : "+title, Toast.LENGTH_SHORT).show();

		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
    	
    }
    
    //嵮  ȭ  ..
    private void saveView( View view ) 
    { 
       String path = 
    	   Environment.getExternalStorageDirectory().getAbsolutePath();
       
       Bitmap  b = Bitmap.createBitmap( 
    		   view.getWidth(), view.getHeight(), Bitmap.Config.RGB_565);
       if(b!=null){
       try { 
	       File f = new File(path+"/notes");
	       f.mkdir();
	       File f2 = new File(path + "/notes/"+title+".png");
	       
	       Canvas c = new Canvas( b ); 
	       view.draw( c ); 
	       FileOutputStream fos = new FileOutputStream(f2);
	       
	
	                if ( fos != null ) 
	                { 
	                        b.compress(Bitmap.CompressFormat.PNG, 100, fos ); 
	                        fos.close(); 
	                } 
	                //setWallpaper( b ); 
	       
	       } catch( Exception e ){ 
	                Log.e("testSaveView", "Exception: " + e.toString() ); 
	       } 
       }
    } 
   
	
}


